#include "postgres.h"
#include "libpq-fe.h"
#include "fmgr.h"

Datum sync_data(PG_FUNCTION_ARGS);

PG_FUNCTION_INFO_V1(sync_data);
Datum
sync_data(PG_FUNCTION_ARGS)
{
	text  		*optstr;
	text  		*jpgsql;
	PGconn		*conn;
	PGresult	*res;

	if (PG_ARGISNULL(0) || PG_ARGISNULL(1))
	{
		PG_RETURN_INT32(1);
	}

	optstr = PG_GETARG_TEXT_P(0);
	jpgsql = PG_GETARG_TEXT_P(1);

	conn = PQconnectdb(VARDATA(optstr));
	if (PQstatus(conn) == CONNECTION_BAD)
	{
		PQfinish(conn);
		PG_RETURN_INT32(2);
	}

	res = PQexec(conn, "BEGIN");
	if (PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		PQclear(res);
		PQfinish(conn);
		PG_RETURN_INT32(3);
	}
	PQclear(res);

	res = PQexec(conn, VARDATA(jpgsql));
	if (PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		PQclear(res);
		PQfinish(conn);
		PG_RETURN_INT32(4);
	}
	PQclear(res);

	res = PQexec(conn, "END");
	PQclear(res);
	PQfinish(conn);
	PG_RETURN_INT32(0);
}
